// Copyright (c) 2023 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#pragma once
#include "dawnlibs.hpp"

namespace Dawn {
  enum ShaderType {
    VERTEX,
    FRAGMENT,
    COMPUTE
  };

  class IShaderStage {
    public:
      /**
       * Constructs a new Shader Stage.
       * 
       * @param type Type of shader stage.
       */
      IShaderStage(const enum ShaderType type);

      /**
       * Destroy the IShaderStage object
       */
      virtual ~IShaderStage();
  };
}