// Copyright (c) 2023 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#pragma once
#include "dawnopengl.hpp"
#include "dawnlibs.hpp"
#include "display/shader/IShaderStage.hpp"

namespace Dawn {
  class ShaderStage {
    public:
      GLuint id = -1;
      const enum ShaderType type;

      /**
       * Constructs a new ShaderStage.
       * 
       * @param type The type of shader this is.
       */
      ShaderStage(const enum ShaderType type);

      /**
       * Compiles the shader stage.
       * 
       * @param source The source code to compile.
       */
      void compile(const std::string source);

      /**
       * Disposes of the shader stage.
       */
      virtual ~ShaderStage();
  };
}